diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
index 06caf9c42..d40cea63a 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.block.model.BlockModelStandard;
-import net.minecraft.client.render.stitcher.AtlasStitcher;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 
 public class DynamicTextureWaterStill extends DynamicTexture {
+	
+	private final Minecraft mc = Minecraft.getMinecraft(this);
 
 	private float[] arr1;
 	private float[] arr2;
@@ -75,7 +75,7 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 			int b = 255;
 			int a = (int) (146.0F + var13 * 50.0F);
 
-			if (Minecraft.getMinecraft(this).gameSettings.biomeWater.value) {
+			if (mc.gameSettings.biomeWater.value) {
 				r = g = b = (r + g + b) / 3;
 			}
 
diff --git a/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java b/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
index eeb103680..bc5ca629c 100644
--- a/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
@@ -19,6 +19,8 @@ import org.lwjgl.opengl.GL11;
 
 public class BoatRenderer extends EntityRenderer<EntityBoat>
 {
+	
+	private final Minecraft mc = Minecraft.getMinecraft(this);
 
     public BoatRenderer()
     {
@@ -45,7 +47,7 @@ public class BoatRenderer extends EntityRenderer<EntityBoat>
         }
         if (entity.tileEntityFlag != null)
         {
-            World theWorld = Minecraft.getMinecraft(this).theWorld;
+            World theWorld = mc.theWorld;
             WindManager theWind = theWorld.getWorldType().getWindManager();
 
             float windAngle = theWind.getWindDirection(theWorld, (float) x, (float) y, (float) z) * 360f + (180 - yaw);
diff --git a/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index bb1fd2116..e2ffd69e5 100644
--- a/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -1,20 +1,22 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.tessalator.Tessellator;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import org.lwjgl.opengl.GL11;
+
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ImageParser;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderEngine;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-import org.lwjgl.opengl.GL11;
 
 public abstract class EntityRenderer<T extends Entity>
 {
@@ -54,6 +56,11 @@ public abstract class EntityRenderer<T extends Entity>
         GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
         GL11.glTranslatef(0.0F, 0.0F, -0.3F + (float)(int)f12 * 0.02F);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        if(LightmapHelper.isLightmapEnabled()) {
+        	int lightmapCoord = entity.getLightmapCoord(partialTick);
+        	lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
+        	LightmapHelper.setLightmapCoord(lightmapCoord);
+        }
         float f14 = 0.0F;
         int l = 0;
         tessellator.startDrawingQuads();
@@ -143,7 +150,7 @@ public abstract class EntityRenderer<T extends Entity>
             return;
         }
         double brightness = getWorld().getLightBrightness(x, y, z);
-        if (Minecraft.getMinecraft(this).fullbright) brightness = 1.0f;
+        if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
         double alpha = ((double)opacity - (d1 - ((double)(y + 1) + d4)) / 2D) * 0.5D * brightness;
         if(alpha < 0.0D)
         {
diff --git a/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java b/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
index 45e614f14..48e4f5b90 100644
--- a/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.block.ItemBlock;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
@@ -48,8 +49,10 @@ public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 	}
 
 	public void doRender(Tessellator tessellator, final EntityItem entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-		final Minecraft mc = Minecraft.getMinecraft(this);
-		float brightness = entity.getBrightness(partialTick);
+		float brightness = 1.0f;
+		if(!LightmapHelper.isLightmapEnabled()) {
+			brightness = entity.getBrightness(partialTick);
+		}
 		random.setSeed(187L);
 		final ItemStack itemstack = entity.item;
 		if(itemstack == null) {
diff --git a/src/main/java/net/minecraft/client/render/entity/LivingRenderer.java b/src/main/java/net/minecraft/client/render/entity/LivingRenderer.java
index 5e18a3963..a39bda049 100644
--- a/src/main/java/net/minecraft/client/render/entity/LivingRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/LivingRenderer.java
@@ -2,9 +2,11 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.model.ModelBase;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
@@ -94,7 +96,7 @@ public class LivingRenderer<T extends EntityLiving> extends EntityRenderer<T>
 
             renderEquippedItems(entity, partialTick);
             float f9 = entity.getBrightness(partialTick);
-            if (Minecraft.getMinecraft(this).fullbright) f9 = 1.0f;
+            if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) f9 = 1.0f;
             int j = getColorMultiplier(entity, f9, partialTick);
             if((j >> 24 & 0xff) > 0 || entity.hurtTime > 0 || entity.deathTime > 0)
             {
diff --git a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
index e183a50ca..37c909384 100644
--- a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3d;
@@ -83,7 +84,7 @@ public class MinecartRenderer extends EntityRenderer<EntityMinecart>
             GL11.glTranslatef(0.0F, 0.3125F, 0.0F);
             GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
             float brightness = minecart.getBrightness(f1);
-            if (Minecraft.getMinecraft(this).fullbright) brightness = 1.0f;
+            if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
             if(minecart.minecartType == 1)
             {
                 BlockModelDispatcher.getInstance().getDispatch(Block.chestPlanksOak).renderBlockOnInventory(tessellator, 0, brightness);
diff --git a/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java b/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
index d5792995d..d922e676c 100644
--- a/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
@@ -125,7 +126,7 @@ public class PaintingRenderer extends EntityRenderer<EntityPainting>
             worldZ = MathHelper.floor_double(entity.z + (double)(centerX / 16F));
         }
         float brightness = renderDispatcher.world.getLightBrightness(worldX, worldY, worldZ);
-        if (Minecraft.getMinecraft(this).fullbright) brightness = 1.0f;
+        if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
         GL11.glColor3f(brightness, brightness, brightness);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java b/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
index f6a7506a8..7d5359f1f 100644
--- a/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
@@ -1,9 +1,11 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
+import org.lwjgl.opengl.GL11;
+
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.model.ModelBase;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.animal.EntitySheep;
-import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
 //            RenderLiving, EntitySheep, ModelBase, EntityLiving
@@ -22,10 +24,14 @@ public class SheepRenderer extends LivingRenderer<EntitySheep>
         if(i == 0 && !entitysheep.getSheared())
         {
             loadTexture("/mob/sheep_fur.png");
-            float f1 = entitysheep.getBrightness(f);
-            if (Minecraft.getMinecraft(this).fullbright) f1 = 1.0f;
+            float brightness = 1.0f;
+            if(LightmapHelper.isLightmapEnabled() || Global.accessor.isFullbrightEnabled()) {
+            	
+            }else {
+            	brightness = entitysheep.getBrightness(f);
+            }
             int j = entitysheep.getFleeceColor();
-            GL11.glColor3f(f1 * EntitySheep.fleeceColorTable[j][0], f1 * EntitySheep.fleeceColorTable[j][1], f1 * EntitySheep.fleeceColorTable[j][2]);
+            GL11.glColor3f(brightness * EntitySheep.fleeceColorTable[j][0], brightness * EntitySheep.fleeceColorTable[j][1], brightness * EntitySheep.fleeceColorTable[j][2]);
             return true;
         } else
         {
diff --git a/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java b/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
index 7b7d37cf3..c764fa89b 100644
--- a/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.model.ModelSpider;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.monster.EntitySpider;
 import org.lwjgl.opengl.GL11;
 
@@ -28,7 +29,7 @@ public class SpiderRenderer extends LivingRenderer<EntitySpider>
         {
             loadTexture("/mob/spider_eyes.png");
             float brightness = spider.getBrightness(1.0f);
-            if (Minecraft.getMinecraft(this).fullbright) brightness = 1.0f;
+            if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
             float f1 = (1.0F - brightness) * 0.5F;
             GL11.glEnable(3042 /*GL_BLEND*/);
             GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
diff --git a/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java b/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
index 67843681d..9f7f72d5a 100644
--- a/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.entity.EntityTNT;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import org.lwjgl.opengl.GL11;
 
@@ -49,7 +50,7 @@ public class TNTRenderer extends EntityRenderer<EntityTNT>
         float f3 = (1.0F - (((float)tnt.fuse - f1) + 1.0F) / 100F) * 0.8F;
         TextureRegistry.blockAtlas.bindTexture();
         float brightness = tnt.getBrightness(f1);
-        if (Minecraft.getMinecraft(this).fullbright) brightness = 1.0f;
+        if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
         BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(Block.tnt);
         model.renderBlockOnInventory(tessellator, 0, brightness);
         if((tnt.fuse / 5) % 2 == 0)
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index 772fbd1e0..1657eab7a 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -3,12 +3,14 @@ package net.minecraft.client.render.item.model;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
@@ -35,9 +37,19 @@ public class ItemModelBlock extends ItemModelStandard {
     @Override
     public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick) {
         final Minecraft mc = Minecraft.getMinecraft(this);
-        float brightness = player.getBrightness(1.0f);
-        if (mc.fullbright || itemfullBright) brightness = 1.0f;
-
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	int lightmapCoord = player.getLightmapCoord(partialTick);
+        	if(itemfullBright) {
+        		lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
+        	}
+        	LightmapHelper.setLightmapCoord(lightmapCoord);	
+        }else if(mc.fullbright || itemfullBright) {
+        	
+        }else {
+        	brightness = player.getBrightness(1.0f);
+        }
+        
         final float distanceScale = 0.8F; // Relates to how close the held item renders from the camera
         final float swingProgress = player.getSwingProgress(partialTick);
         final float animationProgress2 = MathHelper.sin(swingProgress * MathHelper.PI);
@@ -138,7 +150,13 @@ public class ItemModelBlock extends ItemModelStandard {
                     final float rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / itemSize;
                     GL11.glTranslatef(rOffX, rOffY, rOffZ);
                 }
-                if (Minecraft.getMinecraft(this).fullbright || itemfullBright) brightness = 1.0f;
+                if(LightmapHelper.isLightmapEnabled()) {
+                	brightness = 1.0f;
+                	LightmapHelper.setLightmapCoord(entity.getLightmapCoord(partialTick));
+                }
+                if (Global.accessor.isFullbrightEnabled() || itemfullBright) {
+                	brightness = 1.0f;
+                }
                 blockModel.renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness);
                 GL11.glPopMatrix();
             }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index bef9f0d97..3bc301f0e 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -203,6 +203,8 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
 
         addDispatch(new ItemModelStandard(Item.rope, "minecraft"));
 
+        addDispatch(new ItemModelStandard(Item.wandMonsterSpawner, "minecraft").setFull3D());
+
         addDispatch(new ItemModelStandard(Item.record13, "minecraft"));
         addDispatch(new ItemModelStandard(Item.recordCat, "minecraft"));
         addDispatch(new ItemModelStandard(Item.recordBlocks, "minecraft"));
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index c93496e82..dd6766d9f 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.ItemRenderer;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderEngine;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
@@ -37,6 +38,7 @@ import static org.lwjgl.opengl.GL11.glScaled;
 import static org.lwjgl.opengl.GL11.glTranslated;
 
 public class ItemModelStandard extends ItemModel{
+    final Minecraft mc = Minecraft.getMinecraft(Minecraft.class);
     public static final IconCoordinate ITEM_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:item/texture_missing");
     public static final IconCoordinate ITEM_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:item/texture_unassigned");
     protected boolean useColor = true;
@@ -55,9 +57,18 @@ public class ItemModelStandard extends ItemModel{
 
     @Override
     public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick) {
-        final Minecraft mc = Minecraft.getMinecraft(Minecraft.class);
-        float brightness = player.getBrightness(1f);
-        if (mc.fullbright || itemfullBright) brightness = 1.0f;
+        float brightness = 1.0f;
+        if(mc.fullbright || itemfullBright || LightmapHelper.isLightmapEnabled()) {
+        	if(LightmapHelper.isLightmapEnabled()) {
+            	int lightmapCoord = player.getLightmapCoord(partialTick);
+            	if(itemfullBright) {
+            		lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
+            	}
+            	LightmapHelper.setLightmapCoord(lightmapCoord);	
+        	}
+        }else {
+        	brightness = player.getBrightness(1.0f);
+        }
 
         final float distanceScale = 0.8F; // Relates to how close the held item renders from the camera
         final float swingProgress = player.getSwingProgress(partialTick);
@@ -100,7 +111,6 @@ public class ItemModelStandard extends ItemModel{
 
     @Override
     public void renderItemThirdPerson(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform) {
-        final Minecraft mc = Minecraft.getMinecraft(Minecraft.class);
         float brightness = entity.getBrightness(1f);
         if (mc.fullbright || itemfullBright) brightness = 1.0f;
 
diff --git a/src/main/java/net/minecraft/client/render/model/ModelSheepOverlay.java b/src/main/java/net/minecraft/client/render/model/ModelSheepOverlay.java
index f47de9ca7..67dcf5de7 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelSheepOverlay.java
+++ b/src/main/java/net/minecraft/client/render/model/ModelSheepOverlay.java
@@ -5,6 +5,8 @@ package net.minecraft.client.render.model;
 //            ModelQuadruped, ModelRenderer
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.animal.EntitySheep;
 import org.lwjgl.opengl.GL11;
@@ -24,7 +26,7 @@ public class ModelSheepOverlay extends ModelSheep
         super.setLivingAnimations(entityliving, limbSwing, limbYaw, partialTick);
         this.sheep = entityliving;
         float brightness = sheep.getBrightness(limbSwing);
-        if (Minecraft.getMinecraft(this).fullbright) brightness = 1.0f;
+        if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
         int j = ((EntitySheep)sheep).getFleeceColor();
         GL11.glColor3f(brightness * EntitySheep.fleeceColorTable[j][0], brightness * EntitySheep.fleeceColorTable[j][1], brightness * EntitySheep.fleeceColorTable[j][2]);
 
diff --git a/src/main/java/net/minecraft/client/render/model/ModelWolf.java b/src/main/java/net/minecraft/client/render/model/ModelWolf.java
index b41ec8e0a..4421ca952 100644
--- a/src/main/java/net/minecraft/client/render/model/ModelWolf.java
+++ b/src/main/java/net/minecraft/client/render/model/ModelWolf.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.model;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.core.Global;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.animal.EntityWolf;
 import net.minecraft.core.util.helper.MathHelper;
@@ -124,7 +125,7 @@ public class ModelWolf extends ModelBase
         if(entitywolf.getWolfShaking())
         {
             float brightness = entitywolf.getBrightness(partialTick);
-            if (Minecraft.getMinecraft(this).fullbright) brightness = 1.0f;
+            if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
             float f4 = brightness * entitywolf.getShadingWhileShaking(partialTick);
             GL11.glColor3f(f4, f4, f4);
         }
diff --git a/src/main/java/net/minecraft/client/render/tessalator/TessellatorStandard.java b/src/main/java/net/minecraft/client/render/tessalator/TessellatorStandard.java
index da405a480..98896a081 100644
--- a/src/main/java/net/minecraft/client/render/tessalator/TessellatorStandard.java
+++ b/src/main/java/net/minecraft/client/render/tessalator/TessellatorStandard.java
@@ -176,6 +176,7 @@ public class TessellatorStandard extends Tessellator
             hasNormals = false;
             hasColor = false;
             hasTexture = false;
+            hasLightmap = false;
             isColorDisabled = false;
         }
     }
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
index aa159027a..e4fa63ce9 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
 import net.minecraft.core.world.World;
@@ -29,7 +30,7 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
             GL11.glScalef(scaleValue, scaleValue, scaleValue);
             GL11.glTranslatef(0.66F, 0.75F, 0.66F);
             float lightLevel = Minecraft.getMinecraft(this).theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
-            if (Minecraft.getMinecraft(this).fullbright) lightLevel = 1.0f;
+            if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
             BlockModel.setRenderBlocks(renderBlocks);
             BlockModelDispatcher.getInstance().getDispatch(block).renderBlockOnInventory(tessellator, 0, lightLevel);
         }
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java
index 4e6926f9d..82b6332b3 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntityMeshGold;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -25,7 +26,7 @@ public class TileEntityRendererMesh extends TileEntityRenderer<TileEntityMeshGol
         GL11.glTranslatef((float) x + 0.5f, (float) y + bobbingOffset + 0.25f, (float) z + 0.5f);
 
         float lightLevel = Minecraft.getMinecraft(this).theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
-        if (Minecraft.getMinecraft(this).fullbright) lightLevel = 1.0f;
+        if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
         BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
         GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
         ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderAsItemEntity(TessellatorStandard.instance, null, tileEntity.worldObj.rand, tileEntity.filterItem, 1, f3, lightLevel, renderPartialTicks);
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 87042fdd4..4f8801ad8 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -18,6 +18,8 @@ import org.lwjgl.opengl.GL11;
 public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 {
 
+	private final Minecraft mc = Minecraft.getMinecraft(this);
+	
     public TileEntityRendererSign()
     {
         signModel = new ModelSign();
@@ -80,7 +82,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glPopMatrix();
         
         // Render text
-        float lightLevel = Minecraft.getMinecraft(this).theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
+        float lightLevel = mc.theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         
         GL11.glPushMatrix();
         f4 = 0.01666667F * scale;
diff --git a/src/main/java/net/minecraft/client/util/helper/Colors.java b/src/main/java/net/minecraft/client/util/helper/Colors.java
index b9d520cab..a0c46dd94 100644
--- a/src/main/java/net/minecraft/client/util/helper/Colors.java
+++ b/src/main/java/net/minecraft/client/util/helper/Colors.java
@@ -7,11 +7,12 @@ import java.io.InputStream;
 import javax.imageio.ImageIO;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.util.helper.Color;
 
 public abstract class Colors {
 	
+	private static Minecraft mc = Minecraft.getMinecraft(Colors.class);
+	
 	public static final Color[] allChatColors = new Color[16];
 	public static final Color[] allPlankColors = new Color[16];
 	public static final Color[] allLampColors = new Color[16];
@@ -30,7 +31,7 @@ public abstract class Colors {
 	
 	public static void fillColorArray(String path, Color[] colors) {
 		try {
-			InputStream stream = Minecraft.getMinecraft(Colors.class).texturePackList.getResourceAsStream(path);
+			InputStream stream = mc.texturePackList.getResourceAsStream(path);
 			BufferedImage image = ImageIO.read(stream);
 			stream.close();
 			fillColorArray(colors, image);
